﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Linq;

namespace XmlClassifier.Helpers
{
	public static class StringExt
	{
		/// <summary>
		/// Zamienia dokument z formatu Zakiego w dokument XML
		/// </summary>
		/// <param name="p">Dokument w formacie Zakiego</param>
		/// <returns>Dokument w postaci drzewa XML</returns>
		public static XElement Parse(this string p, int start = 0)
		{
			string prefix = "p";
			string[] elements = p.Split(' ');

			XElement result = new XElement(prefix + elements[start]);
			XElement current = result;

			int i = start;
			while (++i < elements.Length)
			{
				if (elements[i] == "-1")
				{
					current = current.Parent;
				}
				else
				{
					XElement child = new XElement(prefix + elements[i]);
					current.Add(child);
					current = child;
				}
			}

			return result;
		}
	}
}
