﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Plossum.CommandLine;

namespace XmlStreamClassifier
{
	[CommandLineManager(ApplicationName = "XmlStreamClassifier", Copyright = "Copyright (c) Dariusz Brzeziński & Maciej Piernik")]
	public class Options
	{
		[CommandLineOption(Description = "Displays this help text")]
		public bool Help = false;

		[CommandLineOption(Description = "Display author information.")]
		public bool NoInfo = false;

		[CommandLineOption(Description = "Dataset file path", MinOccurs = 1)]
		public string Dataset;

		[CommandLineOption(Description = "Minimal support parameter for pattern mining (0-1)")]
		public double Minsup = 0.05;

		[CommandLineOption(Description = "Size of a single batch for each class")]
		public int BatchSize = 100;

		[CommandLineOption(Description = "Frequency of printing out evaluation statistics")]
		public int SamplingFrequency = 1000;

		[CommandLineOption(Description = "Decides whether classifier is updated simultanously for all classes, or for each class separately")]
		public bool SynchronizedUpdate = false;

		[CommandLineOption(Description = "Dicides whether to weight votes of each pattern by its size.")]
		public bool WeightSize = false;

		[CommandLineOption(Description = "Dicides whether to weight votes of each pattern by its support.")]
		public bool WeightSupport = false;

		[CommandLineOption(Description = "Dicides whether to display results for each batch.")]
		public bool DisplayIntermediateResults = false;

		[CommandLineOption(Description = "Dicides whether to display accuracy for each batch separately.")]
		public bool DisplayLastBatchAccuracy = false;

		[CommandLineOption(Description = "Dicides whether to display processing time.")]
		public bool DisplayTime = false;

		[CommandLineOption(Description = "Dicides whether to display memory usage. Only applicable when intermediate accuracy is displayed.")]
		public bool DisplayMemory = false;

		[CommandLineOption(Description = "Dicides whether to forget patterns when they slide out of the window.")]
		public bool Window = false;

		[CommandLineOption(Description = "Size of the sliding window for pattern mining.")]
		public int WindowSize = 1000;

        [CommandLineOption(Description = "Dicides whether to generate Arff file for Moa testing. This produces "
        + "a datasets of tuples with attributes saying wether a current frequent pattern occurrs in a document or not."
        + "Arff dataset generation excludes normal classification - the program will only generate a dataset.")]
        public bool GenerateArff = false;
	}
}